;
; Draw Sierpinski curve of order n.
;

sier:

$i	equ	254
$h	equ	252
$n	equ	250

	php
	rep	#0x30

	sta	<$n

	lda	##7
	trb	Capctl

	stz	<$i
	lda	##256
	sta	<$h
	lda	##512+128
	sta	<xpos
	lda	##768
	sta	<ypos

	lda	<$n
;	phk
;	bsl	getb
	and	##0xff
	bne	$ok
	brl	$done
$ok	cmp	##9
	bcc	$ok1
	brl	$done
$ok1	sta	<$n
$loop:
	inc	<$i
	sec
	lda	<xpos
	sbc	<$h
	sta	<xpos
	lsr	<$h
	clc
	lda	<ypos
	adc	<$h
	sta	<ypos
	lda	<$i
	cmp	<$n
	bne	$loop

	lda	<$h
	tax
	eor	##-1
	inc	a
	tay
	
	bsl	$sa
$w1:
	bit	Dpdone-1
	bvc	$w1
	lda	<xpos
	sta	Xcap
	lda	<ypos
	sta	Ycap

	stx	0xfe00
	nop
	sty	0xfe02
	nop
	sta	DaDvr
	clc
	txa
	adc	<xpos
	sta	<xpos
	clc
	tya
	adc	<ypos
	sta	<ypos

	bsl	$sb
$w2:
	bit	Dpdone-1
	bvc	$w2
	lda	<xpos
	sta	Xcap
	lda	<ypos
	sta	Ycap

	sty	0xfe00
	nop
	sty	0xfe02
	nop
	sta	DaDvr
	clc
	tya
	adc	<xpos
	sta	<xpos
	clc
	tya
	adc	<ypos
	sta	<ypos

	bsl	$sc
$w3:
	bit	Dpdone-1
	bvc	$w3
	lda	<xpos
	sta	Xcap
	lda	<ypos
	sta	Ycap

	sty	0xfe00
	nop
	stx	0xfe02
	nop
	sta	DaDvr
	clc
	tya
	adc	<xpos
	sta	<xpos
	clc
	txa
	adc	<ypos
	sta	<ypos

	bsl	$sd
$w4:
	bit	Dpdone-1
	bvc	$w4
	lda	<xpos
	sta	Xcap
	lda	<ypos
	sta	Ycap

	stx	0xfe00
	nop
	stx	0xfe02
	nop
	sta	DaDvr
	clc
	txa
	adc	<xpos
	sta	<xpos
	clc
	txa
	adc	<ypos
	sta	<ypos
$done:
	plp
	rtl

$sa:
	lda	<$i
	bne	$a1
	rts
$a1:
	dec	<$i

	bsl	$sa
$w5:
	bit	Dpdone-1
	bvc	$w5
	lda	<xpos
	sta	Xcap
	lda	<ypos
	sta	Ycap

	stx	0xfe00
	nop
	sty	0xfe02
	nop
	sta	DaDvr
	clc
	txa
	adc	<xpos
	sta	<xpos
	clc
	tya
	adc	<ypos
	sta	<ypos
	
	bsl	$sb
$w6:
	bit	Dpdone-1
	bvc	$w6
	lda	<xpos
	sta	Xcap
	lda	<ypos
	sta	Ycap

	txa
	asl	a
	sta	0xfe00
	nop
	stz	0xfe02
	nop
	sta	DaDvr
	txa
	asl	a
	adc	<xpos
	sta	<xpos


	bsl	$sd
$w7:
	bit	Dpdone-1
	bvc	$w7
	lda	<xpos
	sta	Xcap
	lda	<ypos
	sta	Ycap

	stx	0xfe00
	nop
	stx	0xfe02
	nop
	sta	DaDvr
	clc
	txa
	adc	<xpos
	sta	<xpos
	clc
	txa
	adc	<ypos
	sta	<ypos


	bsl	$sa

	inc	<$i
	rts

$sb:
	lda	<$i
	bne	$b1
	rts
$b1:
	dec	<$i

	bsl	$sb
$w8:
	bit	Dpdone-1
	bvc	$w8
	lda	<xpos
	sta	Xcap
	lda	<ypos
	sta	Ycap

	sty	0xfe00
	nop
	sty	0xfe02
	nop
	sta	DaDvr
	clc
	tya
	adc	<xpos
	sta	<xpos
	clc
	tya
	adc	<ypos
	sta	<ypos

	
	bsl	$sc
$w9:
	bit	Dpdone-1
	bvc	$w9
	lda	<xpos
	sta	Xcap
	lda	<ypos
	sta	Ycap

	tya
	asl	a
	sta	0xfe02
	nop
	stz	0xfe00
	nop
	sta	DaDvr
	tya
	asl	a
	clc
	adc	<ypos
	sta	<ypos


	bsl	$sa
$w10:
	bit	Dpdone-1
	bvc	$w10
	lda	<xpos
	sta	Xcap
	lda	<ypos
	sta	Ycap

	stx	0xfe00
	nop
	sty	0xfe02
	nop
	sta	DaDvr
	clc
	txa
	adc	<xpos
	sta	<xpos
	clc
	tya
	adc	<ypos
	sta	<ypos


	bsl	$sb

	inc	<$i
	rts
$sc:
	lda	<$i
	bne	$c1
	rts
$c1:
	dec	<$i

	bsl	$sc
$w11:
	bit	Dpdone-1
	bvc	$w11
	lda	<xpos
	sta	Xcap
	lda	<ypos
	sta	Ycap

	sty	0xfe00
	nop
	stx	0xfe02
	nop
	sta	DaDvr
	clc
	tya
	adc	<xpos
	sta	<xpos
	clc
	txa
	adc	<ypos
	sta	<ypos

	
	bsl	$sd
$w12:
	bit	Dpdone-1
	bvc	$w12
	lda	<xpos
	sta	Xcap
	lda	<ypos
	sta	Ycap

	tya
	asl	a

	sta	0xfe00
	nop
	stz	0xfe02
	nop
	sta	DaDvr
	tya
	asl	a
	clc
	adc	<xpos
	sta	<xpos


	bsl	$sb
$w13:
	bit	Dpdone-1
	bvc	$w13
	lda	<xpos
	sta	Xcap
	lda	<ypos
	sta	Ycap

	sty	0xfe00
	nop
	sty	0xfe02
	nop
	sta	DaDvr
	clc
	tya
	adc	<xpos
	sta	<xpos
	clc
	tya
	adc	<ypos
	sta	<ypos


	bsl	$sc

	inc	<$i
	rts
$sd:
	lda	<$i
	bne	$d1
	rts
$d1:
	dec	<$i

	bsl	$sd
$w14:
	bit	Dpdone-1
	bvc	$w14
	lda	<xpos
	sta	Xcap
	lda	<ypos
	sta	Ycap

	stx	0xfe00
	nop
	stx	0xfe02
	nop
	sta	DaDvr
	clc
	txa
	adc	<xpos
	sta	<xpos
	clc
	txa
	adc	<ypos
	sta	<ypos

	
	bsl	$sa
$w15:
	bit	Dpdone-1
	bvc	$w15
	lda	<xpos
	sta	Xcap
	lda	<ypos
	sta	Ycap

	txa
	asl	a
	sta	0xfe02
	nop
	stz	0xfe00
	nop
	sta	DaDvr
	clc
	txa
	asl	a
	adc	<ypos
	sta	<ypos


	bsl	$sc
$w16:
	bit	Dpdone-1
	bvc	$w16
	lda	<xpos
	sta	Xcap
	lda	<ypos
	sta	Ycap

	sty	0xfe00
	nop
	stx	0xfe02
	nop
	sta	DaDvr
	clc
	tya
	adc	<xpos
	sta	<xpos
	clc
	txa
	adc	<ypos
	sta	<ypos


	bsl	$sd

	inc	<$i
	rts

	end
